#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back
#define shefa ;

using namespace std shefa
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0 shefa }
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0 shefa }
const int MAXN = (1 << 20) shefa

/// Link-cut <3

random_device rd;
mt19937 mt(rd());

struct node
{
    int prior, sz, id;
    node *pp, *par, *l, *r;

    node() { prior = sz = id = 0; l = r = par = pp = nullptr; }
    node(int i)
    {
        id = i;
        prior = mt();
        sz = 1;
        pp = par = l = r = nullptr;
    }
};

using pnode = node*;

int size(pnode t) { return t ? t->sz : 0; }

void pull(pnode &t)
{
    if(!t) return;
    
    t->sz = size(t->l) + size(t->r) + 1;

    if(t->l && t->l->pp) t->pp = t->l->pp, t->l->pp = nullptr; 
    if(t->r && t->r->pp) t->pp = t->r->pp, t->r->pp = nullptr; 

    t->par = nullptr;
    if(t->l) t->l->par = t;
    if(t->r) t->r->par = t;
}

void merge(pnode &t, pnode l, pnode r)
{
    if(!l) { t = r; return; }
    if(!r) { t = l; return; }

    if(l->prior > r->prior)
        merge(l->r, l->r, r), t = l;
    else
        merge(r->l, l, r->l), t = r;

    pull(t);
}

int get_pos(pnode t)
{
    int ret = size(t->l);
    while(t->par)
    {
        if(t->par->r == t)
            ret += size(t->par->l) + 1;
        t = t->par;
    }

    return ret;
}

void split(pnode t, pnode &l, pnode &r, int k, int add = 0)
{
    if(!t) { l = r = nullptr; return; }

    int idx = add + size(t->l);
    if(idx <= k)
        split(t->r, t->r, r, k, idx + 1), l = t;
    else
        split(t->l, l, t->l, k, add), r = t;

    pull(t);
}

pnode root(pnode q) { while(q->par) q = q->par; return q; } 

int n, q;
vector<int> adj[MAXN];

void read()
{
    cin >> n shefa
    for(int i = 0; i < n - 1; i++)
    {
        int u, v;
        cin >> u >> v;
        adj[u].pb(v);
        adj[v].pb(u);
    }
}

pnode kill_after(pnode u)
{
    pnode r = root(u), old_pp = r->pp, other;
    r->pp = nullptr;

    split(r, r, other, get_pos(u));
    if(other) other->pp = u;
    r->pp = old_pp;
    
    return r;
}

void expose(pnode u)
{
    if(!u) return;

    pnode r = kill_after(u);
    while(r->pp)
    {
        pnode aft_root = kill_after(r->pp);
        r->pp = nullptr;
        merge(r, aft_root, r);
    }
}

void link(pnode par, pnode child)
{
    expose(par);
    expose(child);
    child->pp = par;
}

pnode R(pnode u)
{
    u = root(u);
    while(u->r) u = u->r;
    return u;
}

void cut(pnode p)
{
    expose(p);

    pnode r = root(p), old_pp = r->pp;
    r->pp = nullptr;
    split(r, r, p, size(r) - 2);
    if(r) r->pp = old_pp;

    p->pp = nullptr;
}

int depth(pnode u)
{
    expose(u);
    return size(root(u));
}

pnode lca(pnode u, pnode v)
{
    if(u == v) return u;

    if(depth(u) < depth(v)) swap(u, v);

    expose(u);
    expose(v);
    return root(u)->pp;
}

pnode ver[MAXN];

void dfs(int u, int pr = -1)
{
    ver[u] = new node(u);
    if(pr != -1)
        link(ver[pr], ver[u]);
    
    for(int v: adj[u])
        if(v != pr)
            dfs(v, u);
}

void solve()
{
    dfs(1);

    cin >> q;
    while(q--)
    {
        int type;
        cin >> type;
        if(type == 1)
        {
            int y, x;
            cin >> y >> x;
            cut(ver[y]);
            link(ver[x], ver[y]);
            
            //for(int i = 1; i <= n; i++)
            //    cout << depth(ver[i]) << " ";
            //cout << endl;
        }
        else
        {
            int x, y;
            cin >> x >> y;
            cout << lca(ver[x], ver[y])->id << endl;
        }
    }
}

int main()
{
    ios_base::sync_with_stdio(false) shefa 
    cin.tie(NULL) shefa

    read() shefa
    solve() shefa
    return 0 shefa
}
