#include <bits/stdc++.h>
#define endl '\n'

#define SZ(x) ((int)x.size())
#define ALL(V) V.begin(), V.end()
#define L_B lower_bound
#define U_B upper_bound
#define pb push_back
#define shefa ;

#pragma GCC optimize("O3")

using namespace std shefa
template<class T, class T1> int chkmin(T &x, const T1 &y) { return x > y ? x = y, 1 : 0 shefa }
template<class T, class T1> int chkmax(T &x, const T1 &y) { return x < y ? x = y, 1 : 0 shefa }
const int MAXN = (1 << 20) shefa
const int64_t inf = (int64_t)1e18;

/// lower to upper trick <3

struct edge
{
    int64_t w;
    int u, v, pos;
    edge() { u = v = w = pos = 0; }
    edge(int _u, int _v, int64_t _w, int pos)
    {
        u = _u;
        v = _v;
        w = _w;
    }
};

int n, m;
edge e[MAXN];

void read()
{
    cin >> n >> m;    
    for(int i = 0; i < m; i++)
    {
        cin >> e[i].u >> e[i].v >> e[i].w; 
        e[i].pos = i;
    }
}

bool cmp(const edge &x, const edge &y) { return x.w < y.w; }

int64_t answer = inf;
int mn_comps;

struct dsu
{
    int cnt_comps;
    unordered_map<int, int> par, sz;

    void init(int n)
    {
        par.clear();
        sz.clear();
        cnt_comps = n;
    }

    int root(int u)
    {
        if(!par.count(u)) return u;
        return par[u] = root(par[u]);
    }

    void unite(int u, int v)
    {
        if(!sz.count(u)) sz[u] = 1;
        if(!sz.count(v)) sz[v] = 1;

        u = root(u), v = root(v);
        if(u != v) cnt_comps--;
        else return;
        
        if(sz[u] > sz[v]) swap(u, v);

        par[u] = v;
        sz[v] += sz[u];
    }

}d[MAXN];

vector<pair<int, int> > edges[MAXN];

int par[MAXN];
bool used[MAXN];

int root(int u) { return par[u] == u ? u : (par[u] = root(par[u])); }

void Combine(int u, int v)
{
    u = root(u), v = root(v);
    if(SZ(edges[u]) < SZ(edges[v])) swap(u, v);
    par[v] = u;
    
    for(auto it: edges[v])
    {
        edges[u].pb(it);
        d[u].unite(it.first, it.second);
    }

    d[v].init(n);
    edges[v].clear();
}

void enable(int i)
{
    used[i] = true;
    if(i && used[i - 1]) Combine(i, i - 1);
    if(i < m - 1 && used[i + 1]) Combine(i, i + 1);
    chkmin(mn_comps, d[root(i)].cnt_comps);
}

void solve()
{
    for(int i = 0; i < m; i++) 
    {
        par[i] = i;
        d[i].init(n);
        edges[i].pb({e[i].u, e[i].v});
        d[i].unite(e[i].u, e[i].v);
    }

    mn_comps = n;

    sort(e, e + m, cmp);
    for(int i = 0; i < m; )
    {
        int j = i;
        while(i < m && e[i].w == e[j].w)
            i++;

        for(int p = j; p < i; p++)
            enable(e[p].pos);

        //cout << mn_comps << " -> " << e[j].w << endl;
        chkmin(answer, mn_comps * 1ll * e[j].w);
    }

    cout << answer << endl;
}

int main()
{
    ios_base::sync_with_stdio(false) shefa 
    cin.tie(NULL) shefa

    read() shefa
    solve() shefa
    return 0 shefa
}
