/*
Vsicko pisano ot filosofi, poeti -
shte se sbudne!
Bez bog ! Bez gospodar
Septemvri shte bude mai.
Choveshkiqt zhivot
shte bude edin bezkonechen vuzhod -
nagore ! nagore !
Z e m i a t a  s h t e  b u d e  r a i -
shte bude !
*/
#include <iostream>
#include <cstdint>
#include <algorithm>
#include <vector>

const uint32_t MAX_N = 5e5 + 12;
const uint64_t INF = 1ULL << 62;

struct Entry {
	uint32_t par;
	uint32_t sz;
	uint32_t v;
};

template <size_t N>
class DSU {
private:
	std::vector<Entry> s[N];
	//uint32_t par[N];
	//uint32_t sz[N];

	Entry& get(uint32_t i, uint32_t v) {
		while ((!s[i].empty()) && (s[i].back().v > v)) {
			s[i].pop_back();
		}
		if ((s[i].empty()) || (s[i].back().v != v)) {
			s[i].push_back({i, 1, v});
		}
		return s[i].back();
	}

	uint32_t nextV;
public:
	uint32_t get_v() {
		return nextV++;
	}

	DSU() {
		nextV = 1;
		for (uint32_t i = 0;i < N;i++) {
			s[i].reserve(100);
		}
	}

	Entry& find(uint32_t i, uint32_t v) {
		Entry &e = get(i, v);
		if (e.par != i) {
			e.par = find(e.par, v).par;
		}
		return s[e.par].back();
	}
	bool merge(uint32_t i, uint32_t j, uint32_t v) {
		Entry &a = find(i, v);
		Entry &b = find(j, v);

		if (a.par == b.par) {
			return false;
		}

		if (a.sz > b.sz) {
			b.par = a.par;
			a.sz += b.sz;
		} else {
			a.par = b.par;
			b.sz += a.sz;
		}
		return true;
	}
};

struct Edge {
	uint32_t u, v;
	uint64_t t;

	friend bool operator< (const Edge &a, const Edge &b) {
		return a.t < b.t;
	}
};

DSU<MAX_N> dsu;
Edge edges[MAX_N];
uint32_t eCnt, vCnt;

struct AnsT {
	uint64_t ans;
	uint32_t cCnt;
};

struct Node {
	Node *l, *r;
	uint32_t low, high;
	Edge e;

	void print(uint32_t indent = 0) {
		std::cerr << std::string(indent, ' ') << "[" << low << "; " << high << "]\n";
		if (l) {
			std::cerr << std::string(indent, ' ') << "left: \n";
			l->print(indent + 4);
		}
		if (r) {
			std::cerr << std::string(indent, ' ') << "right: \n";
			r->print(indent + 4);
		}

	}
	AnsT solve(uint32_t v = 0) {
		if (v == 0) {
			v = dsu.get_v();
		}
		uint32_t lSz = l ? l->high - l->low + 1 : 0;
		uint32_t rSz = r ? r->high - r->low + 1 : 0;

		Node *sm, *bg;
		if (lSz < rSz) {
			sm = l;
			bg = r;
		} else {
			sm = r;
			bg = l;
		}

		AnsT ans = {INF, vCnt};
		ans.ans = sm ? sm->solve().ans : ans.ans;

		AnsT bgAns = {INF, vCnt};
		if (bg) {
			bgAns = bg->solve(v);
		}
		ans.ans = std::min(ans.ans, bgAns.ans);
		ans.cCnt = bgAns.cCnt;

		if (sm) {
			for (uint32_t i = sm->low;i <= sm->high;i++) {
				ans.cCnt -= dsu.merge(edges[i].u, edges[i].v, v);
			}
		}
		ans.cCnt -= dsu.merge(e.u, e.v, v);
		ans.ans = std::min(ans.ans, e.t * ans.cCnt);

		//std::cerr << "[" << low << "; " << high << "]: " << ans.ans << " " << ans.cCnt << "\n";
		return ans;
	}
};



void input() { 
	std::ios::sync_with_stdio(false);
	std::cin.tie(nullptr);

	std::cin >> vCnt >> eCnt;
	for (uint32_t i = 0;i < eCnt;i++) {
		Edge &e = edges[i];
		std::cin >> e.u >> e.v >> e.t;
		e.u--;
		e.v--;
	}
}


Node cart[MAX_N];
Node* build_cart(uint32_t i, uint64_t maxT);
Node* build_cart_l(Node *l, uint32_t i, uint64_t maxT);

Node *build_cart(uint32_t i, uint64_t maxT) {
	if ((i >= eCnt) || (edges[i].t > maxT)) {
		return nullptr;
	}
	Node *ans = &cart[i];
	ans->low = i;
	ans->e = edges[i];
	ans->l = nullptr;

	ans->r = build_cart(i + 1, edges[i].t);
	ans->high = ans->r ? ans->r->high : i;
	return build_cart_l(ans, ans->high + 1, maxT);
}

Node* build_cart_l(Node *l, uint32_t i, uint64_t maxT) {
	if ((i >= eCnt) || (edges[i].t > maxT)) {
		return l;
	}
	Node *ans = &cart[i];
	ans->l = l;
	ans->low = l ? l->low : i;
	ans->e = edges[i];

	ans->r = build_cart(i + 1, edges[i].t);
	ans->high = ans->r ? ans->r->high : i;

	return build_cart_l(ans, ans->high + 1, maxT);
}

Node* cartRoot;

int main() {
	input();
	cartRoot = build_cart(0, INF);
	//cartRoot->print();
	//AnsT ans = cartRoot->solve();
	//std::cout << ans.ans << "\n";
	//std::cout << solve() << "\n";
}
