#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 500007;

struct edge {
  int v1, v2;
  long long w;
};

struct hash_x {
  int operator () (const int &a) const {
    return a ^ 813290122;
  }
};

struct dynamic_dsu {
  unordered_map < int, int, hash_x > parents;
  int components;

  dynamic_dsu() {
    components = 0;
    //parents.max_load_factor(0.25);
    //sz.max_load_factor(0.25);
  }

  inline void create(int node) {
    if(parents.find(node)==parents.end()) {
      parents[node] = node;
      //sz[node] = 1;
      
      ++components;
    }
  }

  inline int find(int node) {
    create(node);

    while(node!=parents[node]) {
      parents[node] = parents[parents[node]];
      node = parents[node];
    }

    return node;
  }

  inline bool join(int x, int y) {
    x = find(x);
    y = find(y);

    if(x==y) return false;
    
    if(rand()%2==0) { //if(sz[x]>=sz[y]) {
      //sz[x] += sz[y];
      parents[y] = x;
    }
    else {
      //sz[y] += sz[x];
      parents[x] = y;
    }

    --components;
    return true;
  }

  inline int size() {
    return (int)(parents.size());
  }
};

int n, m, from[N], to[N], which[N];
edge e[N];
pair < long long, int > tmp[N];
long long ans;
dynamic_dsu uf[N];
char buff[(1<<24) + 7], *buffp = buff;
bool used[N];
int components;
vector < int > v[N];

inline void read(int &res) {
  res = 0;
  while(*buffp<48) ++buffp;
  while(*buffp>47) res = (res<<3) + (res<<1) + *buffp++ - 48;
}

inline void read(long long &res) {
  res = 0;
  while(*buffp<48) ++buffp;
  while(*buffp>47) res = (res<<3) + (res<<1) + *buffp++ - 48;
}

inline void merge(dynamic_dsu &a, dynamic_dsu &b) {
  unordered_map < int, int, hash_x >::iterator it;
  /*dynamic_dsu ans;

  for(int i=1;i<=n;i++) {
    ans.join(i, a.find(i));
    ans.join(i, b.find(i));
  }

  a = ans;
  return;*/

  for(it=b.parents.begin();a.components + n - a.size()>components && it!=b.parents.end();it++) {
    a.join(it->first, it->second);
  }
}

inline void add_edge(int idx) {
  from[idx] = to[idx] = which[idx] = idx;
  uf[idx].join(e[idx].v1, e[idx].v2);

  if(from[idx - 1]) { //The previous edge has been inserted
    from[idx] = from[idx - 1];

    if(uf[which[idx - 1]].size() > uf[which[idx]].size()) {
      merge(uf[which[idx - 1]], uf[which[idx]]);
      which[idx] = which[idx - 1];
    }
    else {
      merge(uf[which[idx]], uf[which[idx - 1]]);
    }
  }
  if(to[idx + 1]) { //The next edge has been inserted
    to[idx] = to[idx + 1];
    
    if(uf[which[idx + 1]].size() > uf[which[idx]].size()) {
      merge(uf[which[idx + 1]], uf[which[idx]]);
      which[idx] = which[idx + 1];
    }
    else {
      merge(uf[which[idx]], uf[which[idx + 1]]);
    }
  }

  from[from[idx]] = from[idx];
  to[from[idx]] = to[idx];
  which[from[idx]] = which[idx];
  
  from[to[idx]] = from[idx];
  to[to[idx]] = to[idx];
  which[to[idx]] = which[idx];

  //printf("Idx = %d, Weight = %lld, Components = %d\n", idx, e[idx].w, uf[which[idx]].components + n - uf[which[idx]].size());

  ans = min(ans, e[idx].w * (uf[which[idx]].components + n - uf[which[idx]].size()));
}

void dfs(int node) {
  used[node] = true;
  for(int i=0;i<(int)(v[node].size());i++) {
    if(!used[v[node][i]]) dfs(v[node][i]);
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  fread(buff, 1, sizeof(buff), stdin);
  int i;

  read(n);
  read(m);
  for(i=1;i<=m;i++) {
    read(e[i].v1);
    read(e[i].v2);
    read(e[i].w);
    tmp[i] = make_pair(e[i].w, i);
  
    v[e[i].v1].push_back(e[i].v2);
    v[e[i].v2].push_back(e[i].v1);
  }

  for(i=1;i<=n;i++) if(!used[i]) {
    ++components;
    dfs(i);
  }

  sort(tmp + 1, tmp + 1 + m);

  ans = numeric_limits < long long >::max();

  for(i=1;i<=m && clock()<=0.8*CLOCKS_PER_SEC;i++) {
    add_edge(tmp[i].second);
  }

  printf("%lld\n", ans);

  return 0;
}
