#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 100007, LOG = 17, B = 312;

int n, q, current_time, parent[N], jump[N][LOG], level[N], time_in[N], time_out[N], unprocessed_sz;
pair < int, int > unprocessed[N]; //{ Node, Time }
vector < int > v[N];

bool level_cmp(pair < int, int > a, pair < int, int > b) {
  return level[a.first] > level[b.first];
}

bool is_ancestor(int a, int b) {
  return time_in[a]<=time_in[b] && time_out[b]<=time_out[a];
}

void dfs(int node) {
  time_in[node] = ++current_time;
  
  for(int i=0;i<(int)(v[node].size());i++) {
    level[v[node][i]] = level[node] + 1;
    dfs(v[node][i]);
  }

  time_out[node] = ++current_time;
}

void walk_up(int &node, int lvl) {
  for(int i=16;i>=0;i--) if(level[jump[node][i]]>=lvl) node = jump[node][i];
}

int get_lca(int a, int b) {
  if(level[a]>level[b]) swap(a, b);
  walk_up(b, level[a]);

  if(a==b) return a;

  for(int i=16;i>=0;i--) if(jump[a][i]!=jump[b][i]) a = jump[a][i], b = jump[b][i];

  return parent[a];
}

void rebuild() {
  int i, j;

  for(i=1;i<=n;i++) {
    v[i].clear();
  }
  for(i=1;i<=n;i++) {
    v[parent[i]].push_back(i);
  }

  level[1] = 1;
  current_time = 0;
  dfs(1);

  for(i=1;i<=n;i++) {
    jump[i][0] = parent[i];
  }
  for(j=1;j<17;j++) {
    for(i=1;i<=n;i++) {
      jump[i][j] = jump[jump[i][j - 1]][j - 1];
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j, type, x, y;
  
  scanf("%d", &n);
  for(i=1;i<n;i++) {
    scanf("%d %d", &x, &y);
    parent[y] = x;
  }

  rebuild();
  
  scanf("%d", &q);
  while(q--) {
    if((unprocessed_sz + 1)%B==0) {
      rebuild();
      unprocessed_sz = 0;
    }

    scanf("%d %d %d", &type, &x, &y);
    
    if(type==1) {
      parent[x] = y;
      unprocessed[unprocessed_sz++] = make_pair(x, unprocessed_sz);
    }
    else {
      int ans = -1, idx1 = 0, idx2 = 0;

      sort(unprocessed, unprocessed + unprocessed_sz, level_cmp);

      while(true) {
        while(idx1<unprocessed_sz && !is_ancestor(unprocessed[idx1].first, x)) ++idx1;
        while(idx2<unprocessed_sz && !is_ancestor(unprocessed[idx2].first, y)) ++idx2;

        if(idx1==unprocessed_sz || idx2==unprocessed_sz) break;
        
        if(idx1==idx2) {
          ans = get_lca(x, y);
          break;
        }
        else if(unprocessed[idx1].second>unprocessed[idx2].second) {
          x = parent[unprocessed[idx1].first];
          idx1 = 0;
        }
        else {
          y = parent[unprocessed[idx2].first];
          idx2 = 0;
        }
      }

      /*for(i=0;i<unprocessed_sz;i++) {
        if(is_ancestor(unprocessed[i], x) && is_ancestor(unprocessed[i], y)) {
          ans = get_lca(x, y);
          break;
        }

        if(is_ancestor(unprocessed[i], x)) {
          x = parent[unprocessed[i]];
        }
        else if(is_ancestor(unprocessed[i], y)) {
          y = parent[unprocessed[i]];
        }
      }*/

      if(ans==-1) {
        while(idx1<unprocessed_sz) {
          if(is_ancestor(unprocessed[idx1].first, x)) {
            x = parent[unprocessed[idx1].first];
          }
          ++idx1;
        }
        while(idx2<unprocessed_sz) {
          if(is_ancestor(unprocessed[idx2].first, y)) {
            y = parent[unprocessed[idx2].first];
          }
          ++idx2;
        }
        
        ans = get_lca(x, y);
      }

      printf("%d\n", ans);
    }
  }

  return 0;
}
