#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 100007, LOG = 17;

int n, q, parent[N], arr1[N], arr2[N], sz1, sz2, ans, jump[N][LOG], level[N];
unordered_set < int > v[N];

void walk_up(int &node, int lvl) {
  for(int i=16;i>=0;i--) if(level[jump[node][i]]>=lvl) node = jump[node][i];
}

int get_lca(int a, int b) {
  if(level[a]>level[b]) swap(a, b);

  walk_up(b, level[a]);

  if(a==b) return a;

  for(int i=16;i>=0;i--) if(jump[a][i]!=jump[b][i]) a = jump[a][i], b = jump[b][i];

  return parent[a];
}

void dfs(int node) {
  for(auto it: v[node]) {
    level[it] = level[node] + 1;
    dfs(it);
  }
}

void get_subtree(int node, vector < int > &tree) {
  tree.push_back(node);
  for(auto it: v[node]) {
    level[it] = level[node] + 1;
    get_subtree(it, tree);
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j, x, y, type;

  scanf("%d", &n);
  for(i=1;i<n;i++) {
    scanf("%d %d", &x, &y);
    parent[y] = x;
    v[x].insert(y);
  }

  scanf("%d", &q);
 
  if(n<=10000 && q<=10000) {
    while(q--) {
      scanf("%d %d %d", &type, &x, &y);
      
      if(type==1) {
        parent[x] = y;
      }
      else {
        sz1 = 0;
        sz2 = 0;

        while(x) {
          arr1[sz1++] = x;
          x = parent[x];
        }
        while(y) {
          arr2[sz2++] = y;
          y = parent[y];
        }

        ans = -1;
        for(i=sz1-1, j=sz2-1;i>=0 && j>=0;i--, j--) {
          if(arr1[i]==arr2[j]) {
            ans = arr1[i];
          }
          else break;
        }

        printf("%d\n", ans);
      }
    }
  }
  else {
    level[1] = 1;
    dfs(1);
    for(i=1;i<=n;i++) jump[i][0] = parent[i];
    for(j=1;j<17;j++) for(i=1;i<=n;i++) jump[i][j] = jump[jump[i][j - 1]][j - 1];
    
    while(q--) {
      scanf("%d %d %d", &type, &x, &y);

      if(type==1) {
        v[parent[x]].erase(x);
        parent[x] = y;
        v[y].insert(x);

        level[x] = level[y] + 1;
        vector < int > tree;
        get_subtree(x, tree);
      
        
        for(auto i: tree) jump[i][0] = parent[i];
        for(j=1;j<17;j++) for(auto i: tree) jump[i][j] = jump[jump[i][j - 1]][j - 1];
      }
      else {
        printf("%d\n", get_lca(x, y));
      }
    }
  }

  return 0;
}
