#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int N = 100007, LOG = 17, B = 312;

int n, q, current_time, parent[N], jump[N][LOG], level[N], time_in[N], time_out[N], unprocessed_sz;
int unprocessed[N];
vector < int > v[N];
int history1[N], history2[N], sz1, sz2;

bool level_cmp(int a, int b) {
  return level[a] > level[b];
}

bool is_ancestor(int a, int b) {
  return time_in[a]<=time_in[b] && time_out[b]<=time_out[a];
}

void dfs(int node) {
  time_in[node] = ++current_time;
  
  for(int i=0;i<(int)(v[node].size());i++) {
    level[v[node][i]] = level[node] + 1;
    dfs(v[node][i]);
  }

  time_out[node] = ++current_time;
}

void walk_up(int &node, int lvl) {
  for(int i=16;i>=0;i--) if(level[jump[node][i]]>=lvl) node = jump[node][i];
}

int get_lca(int a, int b) {
  if(level[a]>level[b]) swap(a, b);
  walk_up(b, level[a]);

  if(a==b) return a;

  for(int i=16;i>=0;i--) if(jump[a][i]!=jump[b][i]) a = jump[a][i], b = jump[b][i];

  return parent[a];
}

void rebuild() {
  int i, j;

  for(i=1;i<=n;i++) {
    v[i].clear();
  }
  for(i=1;i<=n;i++) {
    v[parent[i]].push_back(i);
  }

  level[1] = 1;
  current_time = 0;
  dfs(1);

  for(i=1;i<=n;i++) {
    jump[i][0] = parent[i];
  }
  for(j=1;j<17;j++) {
    for(i=1;i<=n;i++) {
      jump[i][j] = jump[jump[i][j - 1]][j - 1];
    }
  }
}

int main() {
  ios_base::sync_with_stdio(false);
  cin.tie(NULL);
  int i, j, type, x, y;
  
  scanf("%d", &n);
  for(i=1;i<n;i++) {
    scanf("%d %d", &x, &y);
    parent[y] = x;
  }

  rebuild();
  
  scanf("%d", &q);
  while(q--) {
    if((unprocessed_sz + 1)%B==0) {
      rebuild();
      unprocessed_sz = 0;
    }

    scanf("%d %d %d", &type, &x, &y);
    
    if(type==1) {
      parent[x] = y;
      unprocessed[unprocessed_sz++] = x;
    }
    else {
      if(x==y) {
        printf("%d\n", x);
        continue;
      }
      if(x==1 || y==1) {
        printf("1\n");
        continue;
      }

      int remx = x, remy = y;

      sz1 = sz2 = 0;
     
      sort(unprocessed, unprocessed + unprocessed_sz, level_cmp);
    
      for(int it=1;it<=10;it++) {
        for(i=0;i<unprocessed_sz;i++) {
          if(is_ancestor(unprocessed[i], x)) {
            history1[++sz1] = unprocessed[i];
            x = parent[unprocessed[i]];
          }
        }
        
        for(i=0;i<unprocessed_sz;i++) {
          if(is_ancestor(unprocessed[i], y)) {
            history2[++sz2] = unprocessed[i];
            y = parent[unprocessed[i]];
          }
        }
      }


      for(i=0;i<unprocessed_sz;i++) {
        if(is_ancestor(unprocessed[i], x)) {
          history1[++sz1] = unprocessed[i];
          x = parent[unprocessed[i]];
        }
      }
      history1[++sz1] = 1;
      
      for(i=0;i<unprocessed_sz;i++) {
        if(is_ancestor(unprocessed[i], y)) {
          history2[++sz2] = unprocessed[i];
          y = parent[unprocessed[i]];
        }
      }
      history2[++sz2] = 1;
     
      /*printf("history1: ");
      for(i=1;i<=sz1;i++) printf("%d ", history1[i]);
      printf("\n");
      printf("history2: ");
      for(i=1;i<=sz2;i++) printf("%d ", history2[i]);
      printf("\n");
      */
      map < int, int > inv;
      int idx1 = -1, idx2 = -1;

      for(i=1;i<=sz1;i++) {
        inv[history1[i]] = i;
      }
      for(i=1;i<=sz2;i++) {
        if(inv[history2[i]]) {
          idx1 = inv[history2[i]];
          idx2 = i;
          break;
        }
      }

      int v1, v2;

      --idx1;
      --idx2;

      if(idx1==0) v1 = remx;
      else v1 = parent[history1[idx1]];

      if(idx2==0) v2 = remy;
      else v2 = parent[history2[idx2]];

      printf("%d\n", get_lca(v1, v2));
    }
  }

  return 0;
}
