#include <bits/stdc++.h>

using namespace std;

const long long N = 5e5 + 7;
const long long inf = 1e18;

struct edge{
    long long u, v, t;
};

edge e[N];

long long parent[N], cnt[N];

long long find_parent(long long x){
    if(parent[x] == x){
        return x;
    }

    parent[x] = find_parent(parent[x]);

    return parent[x];
}

bool unite(long long x, long long y){
    if(find_parent(x) == find_parent(y)){
        return false;
    }

    if(cnt[ parent[x] ] < cnt[ parent[y] ]){
        swap(x, y);
    }

    cnt[ parent[x] ] += cnt[ parent[y] ];
    parent[ parent[y] ] = parent[x];

    return true;
}

int main(){
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    long long n, m;

    cin >> n >> m;

    for(long long i = 0; i < m; i++){
        cin >> e[i].u >> e[i].v >> e[i].t;
    }

    long long ans = inf, mx;
    int comp;

    for(int i = 0; i < m; i++){
        if(i != 0 && e[i].t > e[i - 1].t){
            continue;
        }

        for(int j = 1; j <= n; j++){
            parent[j] = j;
            cnt[j] = 1;
        }
        comp = n;
        mx = 0;

        for(int j = i; j < m; j++){
            comp -= unite(e[j].u, e[j].v);
            mx = max(mx, e[j].t);

            ans = min(ans, comp * mx);
        }
    }

    cout << ans << "\n";

    return 0;
}
/*
6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8
*/
