#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#define pb push_back
#define mp make_pair
#define ll unsigned long long
#define pii pair <int, int>
//#pragma gcc optimize("O3")
//#pragma gcc target("sse4")
using namespace std;
const int N = 5e5 + 5;
const ll INF = 1e18;

int n, m;
struct edge{

    int u, v;
    ll w;
    edge() {}
    edge(int _u, int _v, ll _w) {u = _u; v = _v; w = _w;}

};
edge e[N];
int root[N], sz[N];
int get_root(int v)
{
    if(v == root[v])
        return v;
    return root[v] = get_root(root[v]);
}

struct state{

    int ru, rv;

};
vector <state> pers;
void undo_top()
{
    state temp = pers.back();
    pers.pop_back();

    root[temp.rv] = temp.rv;
    sz[temp.ru] -= sz[temp.rv];
}

ll comps;
void merge(int u, int v)
{
    int ru = get_root(u), rv = get_root(v);
    if(ru != rv)
        comps--;

    if(sz[ru] < sz[rv])
        swap(ru, rv);
    sz[ru] += sz[rv];
    root[rv] = ru;

//    state temp;
//    temp.ru = ru;
//    temp.rv = rv;
//    pers.pb(temp);
}

ll solve(int l, int r)
{
    if(l > r)
        return INF;

    ll mx = 0;
    for(int i = l; i <= r; i++)
        mx = max(mx, e[i].w);

    ll ans = INF;
    int rem = (int)pers.size();


    for(int i = 1; i <= n; i++)
    {
        root[i] = i;
        sz[i] = 1;
    }

    comps = n;
    for(int i = l; i <= r; i++)
    {
        if(e[i].u != e[i].v)
            merge(e[i].u, e[i].v);
    }
    ans = min(ans, mx * comps);

//    while((int)pers.size() > rem)
//        undo_top();

    for(int i = l; i <= r;)
    {
        if(e[i].w == mx)
        {
            i++;
            continue;
        }

        int j = i;
        while(j <= r && e[j].w < mx)
            j++;
        ans = min(ans, solve(i, j - 1));
        i = j;
    }

    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int u, v, w;

    cin >> n >> m;
    for(int i = 1; i <= m; i++)
    {
        cin >> u >> v >> w;
        e[i] = edge(u, v, w);
    }
    for(int i = 1; i <= n; i++)
    {
        root[i] = i;
        sz[i] = 1;
    }

    ll ans = solve(1, m);
    cout << ans << endl;


    return 0;
}

/*

6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8

*/
