#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <set>
#include <unordered_set>
#define pb push_back
#define mp make_pair
#define ll long long
#pragma gcc optimize("O3")
#pragma gcc target("sse4")
using namespace std;
const int N = 1e4 + 5;
const int LOGN = 15;
const int SQRTN = 1;

int n, Q;
set <int> nb[N];

int in[N], out[N], timer;
int sparse[N][LOGN], dep[N];
void DFS(int v, int pr = 1)
{
    dep[v] = (v == 1) ? 1 : dep[pr] + 1;
    sparse[v][0] = pr;
    in[v] = out[v] = timer++;

    for(auto u: nb[v])
        if(u != pr)
        {
            DFS(u, v);
            out[v] = max(out[v], out[u]);
        }
}

bool in_subtree(int u, int v)
{
    return (in[u] <= in[v] && out[u] >= in[v]);
}

int LCA(int u, int v)
{
    if(dep[u] > dep[v])
        swap(u, v);
    if(in_subtree(u, v))
        return u;

    for(int i = LOGN - 1; i >= 0; i--)
    {
        if(!in_subtree(sparse[u][i], v))
            u = sparse[u][i];
    }
    return sparse[u][0];
}
struct query{

    int u, v;
    query() {}
    query(int _u, int _v) {u = _u; v = _v;}
};

vector <query> rem;

void apply_queries()
{
    for(query q: rem)
    {
        int u = q.u, v = q.v;
        nb[u].erase(sparse[u][0]), nb[sparse[u][0]].erase(u);
        nb[u].insert(v), nb[v].insert(u), sparse[u][0] = v;
    }
    rem.clear();
}

int temp_par[N];
void from_scratch()
{
    timer = 1;
    DFS(1);
    for(int step = 1; step < LOGN; step++)
        for(int i = 1; i <= n; i++)
            sparse[i][step] = sparse[sparse[i][step - 1]][step - 1];

    for(int i = 1; i <= n; i++)
        temp_par[i] = sparse[i][0];
}

int solve(int u, int v)
{
    vector <int> touched = {u, v};

    for(query q: rem)
    {
        temp_par[q.u] = q.v;
        touched.pb(q.u);

        if(in_subtree(q.u, u) && in_subtree(q.u, v))
            continue;
        if(!in_subtree(q.u, u) && !in_subtree(q.u, v))
            continue;

        if(in_subtree(q.u, u))
            u = temp_par[q.v];
        else
            v = temp_par[q.v];
    }

    for(auto x: touched)
        temp_par[x] = sparse[x][0];

    return LCA(u, v);
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int type, u, v;

    cin >> n;
    for(int i = 1; i < n; i++)
    {
        cin >> u >> v;
        nb[u].insert(v);
        nb[v].insert(u);
    }
    from_scratch();

    cin >> Q;
    for(int i = 1; i <= Q; i++)
    {
        cin >> type >> u >> v;
        if(type == 1)
            rem.pb(query(u, v));

        if(type == 2)
            cout << solve(u, v) << endl;

        if(rem.size() == SQRTN)
        {
            apply_queries();
            from_scratch();
        }
    }

    return 0;
}


/*

5
1 2
1 3
2 4
2 5
8
2 4 3
2 5 5
2 1 2
1 2 3
2 4 3
2 4 5
1 4 3
2 4 5

*/

/*

5
1 2
1 3
2 4
2 5
3
1 2 3
1 4 3
2 4 5

*/
