#include <iostream>
#include <cstdio>
#include <vector>
#include <algorithm>
#include <string>
#include <cstring>
#include <cassert>
#include <ctime>
#include <set>
#include <map>
#define pb push_back
#define mp make_pair
#define ll long long
#define pii pair <int, int>
#pragma gcc optimize("O3")
#pragma gcc target("sse4")
using namespace std;
const int N = 1e5 + 5;
const ll INF = 1e18;

int n, m;
struct edge{

    int u, v;
    ll w;
    edge() {}
    edge(int _u, int _v, ll _w) {u = _u; v = _v; w = _w;}

};
edge e[N];

ll comps[N];
map <int, int> root[N], _sz[N];
int get_root(int v, int id)
{
        if(root[id].count(v) == 0)
            return v;
        if(root[id][v] == v)
            return v;
        return root[id][v] = get_root(root[id][v], id);
}

int sz(int v, int id)
{
        if(_sz[id].count(v) == 0)
            _sz[id][v] = 1;
        return _sz[id][v];
}

ll cur_edge = 1e12;
ll ans = INF;
void merge(int u, int v, int id)
{
        int ru = get_root(u, id), rv = get_root(v, id);
        if(ru == rv)
            return;

        comps[id]--;
        if(sz(ru, id) < sz(rv, id))
            swap(ru, rv);

        root[id][rv] = ru;
        _sz[id][ru] += _sz[id][rv];

        ans = min(ans, cur_edge * comps[id]);
}

int to[N];
void small_to_large(int x, int y)
{
    if(root[x].size() < root[y].size())
        swap(root[x], root[y]);
    for(auto t: root[y])
        merge(t.first, get_root(t.second, y), x);

    to[x] = to[y];
}

set <int> alive;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int u, v, w;

    cin >> n >> m;
    for(int i = 1; i <= m; i++)
        cin >> e[i].u >> e[i].v >> e[i].w;


    vector <pair <ll, int> > to_check;
    for(int i = 1; i <= m; i++)
        to_check.pb({e[i].w, i});

    sort(to_check.begin(), to_check.end());

    for(int i = 1; i <= m; i++)
    {
        to[i] = i;
        comps[i] = n;
    }

    for(int i = 0; i < (int)to_check.size();)
    {
        int j = i;
        cur_edge = to_check[i].first;
        while(j < (int)to_check.size() && to_check[j].first == to_check[i].first)
        {
            int id = to_check[i].second;
            alive.insert(id);
            merge(e[id].u, e[id].v, id);

            j++;
        }
        i = j;

        for(auto it = alive.begin(); it != alive.end();)
        {
            int x = *it;
            if(alive.upper_bound(x) == alive.end())
                break;
            auto y = alive.upper_bound(to[x]);
            while(to[x] + 1 == *y)
            {
                small_to_large(x, *y);
                ++y;
                if(y == alive.end())
                    break;
            }

            it = y;
        }

//        cerr << "PRINTING ALIVE" << endl;
//        for(auto x: alive)
//        {
//            cerr << x << " " << to[x] << endl;
//        }
    }


    cout << ans << endl;

    return 0;
}

/*

6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8

*/
