#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 100003
using namespace std;
mt19937 random_generator(23777991);
typedef long long ll;
typedef long double ld;
struct node
{
    int sz;
    int prior;
    int depth, val;
    pair <int, int> min_el;
    node *left, *right, *par;
    node() {}
    node(int _depth, int _val)
    {
        sz = 1;
        depth = _depth;
        prior = random_generator();
        val = _val;
        min_el = {_depth, _val};
        left = right = par = nullptr;
    }
};
int sz(node *x)
{
    if (x == nullptr)
        return 0;
    return x->sz;
}
pair <int, int> min_el(node *x)
{
    if (x == nullptr)
        return {INT_MAX, -1};
    return x->min_el;
}
void recalc(node *&x)
{
    if (x == nullptr)
        return;
    x->sz = sz(x->left) + sz(x->right) + 1;
    x->min_el = {x->depth, x->val};
    if (min_el(x->left).first < x->min_el.first)
        x->min_el = min_el(x->left);
    if (min_el(x->right).first < x->min_el.first)
        x->min_el = min_el(x->right);
    if (x->left != nullptr)
        x->left->par = x;
    if (x->right != nullptr)
        x->right->par = x;
}
node *merge(node *a, node *b)
{
    if (a == nullptr)
        return b;
    if (b == nullptr)
        return a;
    if (a->prior > b->prior)
    {
        a->right = merge(a->right, b);
        recalc(a);
        return a;
    }
    else
    {
        b->left = merge(a, b->left);
        recalc(b);
        return b;
    }
}
pair <node*, node*> split(node *x, int idx, int add)
{
    if (x == nullptr)
        return {nullptr, nullptr};
    int pos = sz(x->left) + add;
    if (pos <= idx)
    {
        auto temp = split(x->right, idx, pos + 1);
        x->right = temp.first;
        recalc(x);
        return {x, temp.second};
    }
    else
    {
        auto temp = split(x->left, idx, add);
        x->left = temp.second;
        recalc(x);
        return {temp.first, x};
    }
}
int find_idx(node *x)
{
    int idx = sz(x->left);
    auto curr = x;
    for (;;)
    {
        auto par = curr->par;
        if (par == nullptr)
            break;
        if (par->right == curr)
            idx += sz(par->left) + 1;
        curr = par;
    }
    return idx;
}
int n, q;
vector <int> adj[MAXN];
void read()
{
    cin >> n;
    for (int i = 1; i <= n-1; i++)
    {
        int a, b;
        cin >> a >> b;
        adj[a].push_back(b);
    }
    cin >> q;
}
vector <int> order;
int depth[MAXN];
void dfs(int ver, int par)
{
    order.push_back(ver);
    for (auto i: adj[ver])
        if (i != par)
        {
            depth[i] = depth[ver] + 1;
            dfs(i, ver);
            order.push_back(ver);
        }
}
int first_pos[MAXN], last_pos[MAXN];
node *first[MAXN], *last[MAXN];
node *root = nullptr;
void dfs1(node *x, int add)
{
    if (x == nullptr)
        return;
    if (add + sz(x->left) == first_pos[x->val])
    first[x->val] = x;
    if (add + sz(x->left) == last_pos[x->val])
        last[x->val] = x;
    dfs1(x->left, add);
    dfs1(x->right, add + sz(x->left) + 1);
}
void print(node *x, int add)
{
    if (x == nullptr)
        return;
    cout << x->depth << " " << x->val << " " << sz(x->left) + add << endl;
    print(x->left, add);
    print(x->right, add + sz(x->left) + 1);
}
int query(int l, int r)
{
    auto temp1 = split(root, l-1, 0);
    auto temp2 = split(temp1.second, r, l);
    int ans = temp2.first->min_el.second;
    temp1.second = merge(temp2.first, temp2.second);
    root = merge(temp1.first, temp1.second);
    return ans;
}
void update(int x, int y)
{
    int l = find_idx(first[x]);
    int r = find_idx(last[x]);
    int pos = find_idx(first[y]);
    auto temp1 = split(root, pos, 0);
    temp1.first = merge(temp1.first, new node(depth[y], y));
    root = merge(temp1.first, temp1.second);
    if (pos < l)
    {
        auto temp1 = split(root, pos, 0);
        auto temp2 = split(temp1.second, l-1, pos);
        auto temp3 = split(temp2.second, r, l);
        temp1.first = merge(temp1.first, temp3.first);
        temp1.second = merge(temp2.first, temp3.second);
        root = merge(temp1.first, temp1.second);
    }
    else
    {
        auto temp1 = split(root, pos-1, 0);
        auto temp2 = split(temp1.first, l-1, 0);
        auto temp3 = split(temp2.second, r, l);
        auto temp4 = split(temp1.second, pos, pos);
        temp4.first = merge(temp4.first, temp3.first);
        temp1.second = merge(temp4.first, temp4.second);
        temp1.first = merge(temp2.first, temp3.second);
        root = merge(temp1.first, temp1.second);
    }
}
void solve()
{
    depth[1] = 1;
    dfs(1, -1);
    memset(first_pos, -1, sizeof(first_pos));
    memset(last_pos, -1, sizeof(last_pos));
    for (int i = 0; i < order.size(); i++)
        if (first_pos[order[i]] == -1)
            first_pos[order[i]] = i;
    for (int i = order.size() - 1; i >= 0; i--)
        if (last_pos[order[i]] == -1)
            last_pos[order[i]] = i;
    for (int i = 0; i < order.size(); i++)
        root = merge(root, new node(depth[order[i]], order[i]));
    dfs1(root, 0);
    while (q--)
    {
        int type;
        cin >> type;
        if (type == 2)
        {
            int x, y;
            cin >> x >> y;
            int pos1 = find_idx(first[x]);
            int pos2 = find_idx(first[y]);
            if (pos1 > pos2)
                swap(pos1, pos2);
            cout << query(pos1, pos2) << endl;
        }
        else
        {
            int x, y;
            cin >> x >> y;
            update(x, y);
        }
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    read();
    solve();
}
/*
5
1 2
1 3
2 4
2 5
8
2 4 3
2 5 5
2 1 2
1 2 3
2 4 3
2 4 5
1 4 3
2 4 5
*/
