#include <bits/stdc++.h>

const int32_t MAX_N = 5e5;
const int32_t MAX_M = 5e5; 
const int64_t INF = 1e18;

struct Edge {
	int32_t x, y;
	int64_t w;
};

int32_t cntComps, currTime;
int32_t par[MAX_N + 5], siz[MAX_N + 5], tim[MAX_N + 5];
Edge edges[MAX_M + 5];

int32_t find_par(int32_t x) {
	if(tim[x] == currTime && par[x] != x) {
		par[x] = find_par(par[x]);		
	}

	if(tim[x] != currTime) {
		tim[x] = 1;
		par[x] = x;
		tim[x] = currTime;
	}

	return par[x];
}

void unite(int32_t x, int32_t y) {
	if(siz[x] >= siz[y]) {
		par[y] = x;
		siz[x] += siz[y];
	}
	else {
		par[x] = y;
		siz[y] += siz[x];
	}
}

void insert_edge(int32_t x) {
	int32_t px = find_par(edges[x].x);
	int32_t py = find_par(edges[x].y);

	if(px != py) {
		cntComps--;
		unite(px, py);
	}
}

int main() {
	std::ios_base::sync_with_stdio(false);
	std::cin.tie(nullptr);

	int32_t n, m;
	std::cin >> n >> m;

	for(int32_t i = 0; i < m; i++) {
		std::cin >> edges[i].x >> edges[i].y >> edges[i].w;
	}

	int64_t ans = INF, low, high;
	for(int32_t i = 0; i < m; i++) {
		if(i == 0 || edges[i - 1].w > edges[i].w) {
			cntComps = n;
			currTime = i + 1;
			for(int32_t j = i; j >= 0; j--) {
				if(edges[j].w > edges[i].w) {
					low = j + 1;
					break;
				}

				insert_edge(j);
			}

			for(int32_t j = i + 1; j < m; j++) {
				if(edges[j].w > edges[i].w) {
					high = j - 1;
					break;
				}

				insert_edge(j);
			}
		}
		else {
			for(int32_t j = low - 1; j >= 0; j--) {
				if(edges[j].w > edges[i].w) {
					low = j + 1;
					break;
				}

				insert_edge(j);
			}

			for(int32_t j = high + 1; j < m; j++) {
				if(edges[j].w > edges[i].w) {
					high = j - 1;
					break;
				}

				insert_edge(j);
			}
		}

		ans = std::min(ans, edges[i].w * cntComps);
	}

	std::cout << ans << '\n';
}
