#include <iostream>
#include <vector>
#include <utility>
#include <map>
#include <random>
#define fi first
#define se second
using namespace std;

const int MAXN = 100005;
const long long INF = 1ll << 60;

mt19937 rg(4209008);

struct dsu
{
    long long ans, comp;
    map<int, int> vs;
    vector<int> vp;

    void add_vertex(int x)
    {
        if (vs.count(x) == 0)
        {
            int id = vs.size();
            vs[x] = id;
            vp.push_back(id);
        }
    }

    int cheff(int x)
    {
        if (vp[x] == x) return x;
        return vp[x] = cheff(vp[x]);
    }

    void unite(int x, int y)
    {
    //    cout << x << ' ' << y << endl;

        int u = vs[x], v = vs[y];
        u = cheff(u);
        v = cheff(v);
     //   cout << "cheffs "<< endl;

        if (u != v) comp--;

        if (rg() % 2 == 0)
        {
            vp[u] = v;
        }
        else
        {
            vp[v] = u;
        }
    }
};

int n, m;
vector<pair<long long, pair<int, int>>> e;

int cnt = 0;
dsu uf[MAXN * 20];

void Init()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n >> m;
    e.resize(m);
    for (int i = 0; i < m; ++ i)
    {
        int u, v;
        long long w;
        cin >> u >> v >> w;
        e[i] = make_pair(w, make_pair(u, v));
    }
}

int DC(int l = 0, int r = m - 1)
{
    // cout << l << ' ' << r << endl;

    if (l == r)
    {
        ++cnt;

        uf[cnt].comp = n;
        uf[cnt].add_vertex(e[l].se.fi);
        uf[cnt].add_vertex(e[l].se.se);

        uf[cnt].unite(e[l].se.fi, e[l].se.se);
        uf[cnt].ans = uf[cnt].comp * e[l].fi;

        return cnt;
    }

    int mid = (l + r) / 2;

    int lp = DC(l, mid + 0);
    int rp = DC(mid + 1, r);

    ++cnt;
    uf[cnt].comp = n;
    uf[cnt].ans = min(uf[lp].ans, uf[rp].ans);

    for (int i = l; i <= r; ++ i)
    {
        uf[cnt].add_vertex(e[i].se.fi);
        uf[cnt].add_vertex(e[i].se.se);
    }

    int lidx = mid + 0, ridx = mid + 1;
    long long current = 0;
    while (lidx >= l or ridx <= r)
    {
        long long lw = INF, rw = INF;
        if (lidx >= l) lw = e[lidx].fi;
        if (ridx <= r) rw = e[ridx].fi;

        if (lw == INF and rw == INF)
        {
            cout << "impossible" << endl;
            return 0;
        }

        if (lw < rw)
        {
            uf[cnt].unite(e[lidx].se.fi, e[lidx].se.se);
            current = max(current, e[lidx].fi);
            uf[cnt].ans = min(uf[cnt].ans, uf[cnt].comp * current);
            lidx--;
        }
        else
        {
            uf[cnt].unite(e[ridx].se.fi, e[ridx].se.se);
            current = max(current, e[ridx].fi);
            uf[cnt].ans = min(uf[cnt].ans, uf[cnt].comp * current);
            ridx++;
        }
    }

   // cout << "end" << endl;

    return cnt;
}

int main()
{
    Init();

    int idx = DC();
    cout << uf[idx].ans << endl;
    return 0;
}

/*
6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8

6 9
3 3 1000000000000
1 2 1000000000000
4 5 1000000000000
2 4 1000000000000
3 6 1000000000000
5 2 1000000000000
2 1 1000000000000
3 1 1000000000000
1 4 1000000000000

4 6
1 1 9
2 2 7
3 3 8
4 4 4
1 4 5
2 3 6
*/
