#include <iostream>
#include <vector>
#include <cstdio>
#include <ctime>
using namespace std;

typedef long long Int;

const int N=(5e5)+5;
const Int INF=(2e18);

int u[N],v[N];
Int t[N];
int root[N],sz[N];
int cnt;

int Find(int v)
{
  while(v!=root[v])
  {
   root[v]=root[root[v]];
   v=root[v];
  }

 return v;
}

void Union(int p,int q)
{
 int rootp=Find(p);
 int rootq=Find(q);

  if(rootp==rootq)
   return;

 cnt--;

  if(sz[rootp]<sz[rootq])
  {
   root[rootp]=root[rootq];
   sz[rootq]+=sz[rootp];
  }
  else
  {
   root[rootq]=root[rootp];
   sz[rootp]+=sz[rootq];
  }
}

bool NoTime()
{
 return clock()/(double)CLOCKS_PER_SEC>0.98;
}

int main()
{

int n,m,i,j,len,limit,bound,iter;
Int ans,maxcost;

ios::sync_with_stdio(false);
cin.tie(nullptr);

cin>>n>>m;

 for(i=1;i<=m;i++)
  cin>>u[i]>>v[i]>>t[i];

bound=m;

ans=INF;
 for(i=1;i<=m;i++)
 {
   if(NoTime())
    break;

   if(i>1000)
    bound=3000;

   for(j=1;j<=n;j++)
   {
    root[j]=j;
    sz[j]=1;
   }

  limit=min(m,i+bound);
  maxcost=-1;
  cnt=n;
   for(j=i;j<=limit;j++)
   {
    maxcost=max(maxcost,t[j]);

    Union(u[j],v[j]);

    ans=min(ans,maxcost*cnt);
   }
 }

cout<<ans<<"\n";

return 0;
}
