#include <iostream>
#include <vector>
using namespace std;

const int N=(1e5)+5;
const int LOG=20;

int used[N],parent[N][LOG];
vector <int> g[N];
int depth[N];

void DFS(int v,int lev)
{
 int i;

 depth[v]=lev;

  for(i=0;i<g[v].size();i++)
   DFS(g[v][i],lev+1);
}

int LCA(int u,int v)
{
 int diff,i;

   if(depth[u]<depth[v])
    swap(u,v);

  diff=depth[u]-depth[v];

   for(i=LOG-1;i>=0;i--)
   {
     if((diff&(1<<i))!=0)
      u=parent[u][i];
   }

   if(u==v)
    return u;

   for(i=LOG-1;i>=0;i--)
   {
     if(parent[u][i]!=parent[v][i])
     {
      u=parent[u][i];
      v=parent[v][i];
     }
     else
      break;
   }

 return parent[u][0];
}

void Update(int y,int x)
{
 int i;

 parent[y][0]=x;

  for(i=1;i<LOG;i++)
   parent[y][i]=parent[parent[x][i]][0];
}

int main()
{

int type,n,q,i,x,y,u,v,level,root;

ios::sync_with_stdio(false);
cin.tie(nullptr);

cin>>n;

 for(i=1;i<n;i++)
 {
  cin>>u>>v;
  parent[v][0]=u;
  g[u].push_back(v);
 }

 for(level=1;level<LOG;level++)
 {
  for(i=1;i<=n;i++)
   parent[i][level]=parent[parent[i][level-1]][level-1];
 }

 for(root=1;root<=n;root++)
 {
   if(parent[root][0]==0)
    break;
 }

DFS(root,0);

cin>>q;

 for(i=1;i<=q;i++)
 {
  cin>>type>>y>>x;

   if(type==2)
   {
    cout<<LCA(x,y)<<"\n";
    continue;
   }

  Update(y,x);
 }

return 0;
}
