#include <iostream>
#include <vector>
using namespace std;

typedef long long Int;

const int N=(5e5)+5;
const Int INF=(2e18);

struct Edge
{
 int to;
 Int cost;
 bool active;

  Edge(int _to,Int _cost,bool _active)
  {
   to=_to;
   cost=_cost;
   active=_active;
  }
};

vector <Edge> edges;
vector <int> g[N];

int iter;
int used[N];

void DFS(int v)
{
 int i;

 used[v]=iter;

  for(i=0;i<g[v].size();i++)
  {
    if(used[edges[g[v][i]].to]!=iter && edges[g[v][i]].active)
     DFS(edges[g[v][i]].to);
  }
}

int main()
{

int n,m,i,j,u,v,sz,ver;
Int t,maxcost,cnt,ans;

ios::sync_with_stdio(false);
cin.tie(nullptr);

cin>>n>>m;

sz=0;
 for(i=1;i<=m;i++)
 {
  cin>>u>>v>>t;

  sz+=2;
  edges.push_back(Edge(v,t,false));
  g[u].push_back(sz-2);

  edges.push_back(Edge(u,t,false));
  g[v].push_back(sz-1);
 }

ans=INF;
 for(i=1;i<=m;i++)
 {
  maxcost=-1;
   for(j=i;j<=m;j++)
   {
    edges[2*j-2].active=true;
    edges[2*j-1].active=true;
    maxcost=max(maxcost,edges[2*j-2].cost);

    cnt=0;
    iter++;
     for(ver=1;ver<=n;ver++)
     {
      if(used[ver]!=iter)
      {
       DFS(ver);
       cnt++;
      }
     }

    ans=min(ans,maxcost*cnt);
   }

   for(j=i;j<=m;j++)
   {
    edges[2*j-2].active=false;
    edges[2*j-1].active=false;
   }
 }

cout<<ans<<"\n";

return 0;
}
