#include <bits/stdc++.h>

#define endl '\n'
#define sz(x) ((int)x.size())
#define all(x) x.begin(), x.end()
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXN = (int)1e4 + 4;
const int TREE_SIZE = 32768;

int n;
vector<int> graph[MAXN];
int parent[MAXN];

void read() {
    cin >> n;
    for (int i = 1; i < n; i++) {
        int x, y;
        cin >> x >> y;
        graph[x].push_back(y);
        parent[y] = x;
    }
}

int euler_ptr = 0;
int euler_tour[MAXN << 1], level[MAXN << 1], first[MAXN];

void dfs(int node, int level) {
    euler_tour[euler_ptr] = node;
    ::level[euler_ptr] = level;
    if (first[node] == -1) first[node] = euler_ptr;
    euler_ptr++;
    for (int adj : graph[node]) {
        dfs(adj, level + 1);
        euler_tour[euler_ptr] = node;
        ::level[euler_ptr] = level;
        euler_ptr++;
    }
}

int tree[TREE_SIZE];

int merge(int idx1, int idx2) {
    return level[idx1] < level[idx2] ? idx1 : idx2;
}

void build(int idx, int low, int high) {
    if (low == high) {
        tree[idx] = low;
        return;
    }
    int mid = (low + high) >> 1;
    build(idx << 1, low, mid);
    build(idx << 1 | 1, mid + 1, high);
    tree[idx] = merge(tree[idx << 1], tree[idx << 1 | 1]);
}

int query(int idx, int low, int high, int left, int right) {
    if (low >= left && high <= right) return tree[idx];
    if (high < left || low > right) return -1;
    int mid = (low + high) >> 1;
    int p1 = query(idx << 1, low, mid, left, right);
    int p2 = query(idx << 1 | 1, mid + 1, high, left, right);
    if (p1 == -1) return p2;
    if (p2 == -1) return p1;
    return merge(p1, p2);
}

void update(int x, int y) {
    for (int i = 0; i < sz(graph[parent[y]]); i++) {
        if (graph[parent[y]][i] == y) {
            graph[parent[y]].erase(next(graph[parent[y]].begin(), i));
            break;
        }
    }
    /*
    copy(all(graph[y]), ostream_iterator<int>(cerr, " "));
    cerr << endl;
    */
    graph[x].push_back(y);
    parent[y] = x;
    euler_ptr = 0;
    fill(first + 1, first + n + 1, -1);
    dfs(1, 1);
    build(1, 0, euler_ptr - 1);
}

int lca(int u, int v) {
    u = first[u];
    v = first[v];
    if (u > v) swap(u, v);
    return euler_tour[query(1, 0, euler_ptr - 1, u, v)];
}

void solve() {
    euler_ptr = 0;
    fill(first + 1, first + n + 1, -1);
    dfs(1, 1);
    build(1, 0, euler_ptr - 1);
    int q;
    cin >> q;
    for (int i = 1; i <= q; i++) {
        int type, x, y;
        cin >> type >> x >> y;
        if (type == 1) update(y, x);
        else cout << lca(x, y) << endl;
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}
