#include <bits/stdc++.h>

#define endl '\n'
#define sz(x) ((int)x.size())
#define all(x) x.begin(), x.end()
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXM = 500000;

struct dsu {
    vector<int> parent;
    vector<int> rank;
    int comps;

    void init(int n) {
        this->parent.resize(n + 1, -1);
        this->rank.resize(n + 1, 0);
        this->comps = n;
    }

    int root(int node) {
        if (this->parent[node] == -1) return node;
        return this->parent[node] = this->root(this->parent[node]);
    }

    void unite(int u, int v) {
        u = this->root(u);
        v = this->root(v);
        if (u != v) {
            this->comps--;
            if (this->rank[u] < this->rank[v]) swap(u, v);
            this->parent[v] = u;
            if (this->rank[u] == this->rank[v]) this->rank[u]++;
        }
    }
};

struct edge {
    int u;
    int v;
    long long time;

    edge(int u, int v, long long time) : u(u), v(v), time(time){}
};

struct DP {
    dsu graph;
    long long evaluation_mark;
    long long max_time;
};

int n, m;
vector<edge> edge_list;

void read() {
    cin >> n >> m;
    edge_list.reserve(m + 1);
    for (int i = 1; i <= m; i++) {
        int u, v;
        long long time;
        cin >> u >> v >> time;
        edge_list.emplace_back(u, v, time);
    }
}

DP dp[MAXM];

void solve() {
    for (int i = 0; i < m; i++) dp[i].graph.init(n);
    dp[0].max_time = edge_list[0].time;
    dp[0].evaluation_mark = (long long)(edge_list[0].u == edge_list[0].v ? n : n - 1) * dp[0].max_time;
    if (edge_list[0].u == edge_list[0].v) dp[0].graph.unite(edge_list[0].u, edge_list[0].v);
    for (int i = 1; i < m; i++) {
        long long mark1 = (long long)(edge_list[i].u == edge_list[i].v ? n : n - 1) * edge_list[i].time;
        int comps = dp[i - 1].graph.comps;
        if (dp[i - 1].graph.root(edge_list[i].u) != dp[i - 1].graph.root(edge_list[i].v)) comps--;
        long long max_time = max(edge_list[i].time, dp[i - 1].max_time);
        long long mark2 = comps * max_time;
        if (mark1 < mark2) {
            dp[i].evaluation_mark = mark1;
            dp[i].graph.unite(edge_list[i].u, edge_list[i].v);
            dp[i].max_time = edge_list[i].time;
        } else {
            dp[i].evaluation_mark = mark2;
            dp[i].max_time = max_time;
            dp[i].graph = dp[i - 1].graph;
            dp[i].graph.unite(edge_list[i].u, edge_list[i].v);
        }
    }
    long long ans = (long long)1e18;
    for (int i = 0; i < m; i++) chkmin(ans, dp[i].evaluation_mark);
    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}

/**
6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8
**/
