#include <bits/stdc++.h>

#define endl '\n'
#define sz(x) ((int)x.size())
#define all(x) x.begin(), x.end()
#define trace(x) cerr << #x << " = " << x << endl

using namespace std;
template<class T, class T1> inline bool chkmax(T &x, const T1 &y) { return x < y ? x = y, true : false; }
template<class T, class T1> inline bool chkmin(T &x, const T1 &y) { return x > y ? x = y, true : false; }

const int MAXM = 500000;

struct dsu {
    vector<int> parent;
    vector<int> rank;
    int comps;

    void init(int n) {
        if (this->parent.empty()) this->parent.resize(n + 1, -1);
        else fill(all(this->parent), -1);
        if (this->rank.empty()) this->rank.resize(n + 1, 0);
        else fill(all(this->rank), -1);
        this->comps = n;
    }

    int root(int node) {
        if (this->parent[node] == -1) return node;
        return this->parent[node] = this->root(this->parent[node]);
    }

    void unite(int u, int v) {
        u = this->root(u);
        v = this->root(v);
        if (u != v) {
            this->comps--;
            if (this->rank[u] < this->rank[v]) swap(u, v);
            this->parent[v] = u;
            if (this->rank[u] == this->rank[v]) this->rank[u]++;
        }
    }
};

struct edge {
    int u;
    int v;
    int time;

    edge(int u, int v, int time) : u(u), v(v), time(time){}
};

int n, m;
vector<edge> edge_list;

void read() {
    cin >> n >> m;
    edge_list.reserve(m);
    for (int i = 1; i <= m; i++) {
        int u, v, time;
        cin >> u >> v >> time;
        edge_list.emplace_back(u, v, time);
    }
}

dsu d;

void solve() {
    int ans = INT_MAX;
    int mi, mj;
    for (int i = 0; i < m; i++) {
        int max_time = 0;
        d.init(n);
        for (int j = i; j < m; j++) {
            chkmax(max_time, edge_list[j].time);
            d.unite(edge_list[j].u, edge_list[j].v);
            chkmin(ans, d.comps * max_time);
        }
    }
    cout << ans << endl;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return EXIT_SUCCESS;
}

/**
6 9
3 3 4
1 2 11
4 5 6
2 4 7
3 6 9
5 2 10
2 1 5
3 1 21
1 4 8
**/
